
# watchtower

## Purpose

This mod will watch over players, checking if any of them stacks a tower of blocks.

Tower in this mod is defined to be uninterrupted placings of blocks in the same
x and z coord, with y steadily increasing by 1 each time a block is placed.


## Download

Canonical location of this mod is https://gitea.your-land.de/Ravise/watchtower

## Installation

This mod does not create any releases. Simply git clone the repository. Latest
production version of the code is found in "master" branch.

## Usage

This mod is a library with very limited default settings. Servers are expected
to provide their own integration mod, depending on this library.

### Configuration

This mod vaguely follows yl_template. See 01-config.lua for list of configurable options.

### Hooks

This mod exposes following hooks:

 - watchtower.callbacks.on_maybe_tower
   Called, when player reaches "maybe (33%)" height of stacking blocks.
 - watchtower.callbacks.on_perhaps_tower
   Called, when player reaches "perhaps (66%)" height of stacking blocks.
 - watchtower.callbacks.on_tower
   Called, when player reaches the limit of height.
 - watchtower.callbacks.on_double_tower
   Called, when player reaches double the limit of height.

All hooks are expected to be function with following signature:
> callback = function(player, pos, height)
 - player is ObjRef to the player, who causes the event
 - pos is {x, y, z} table describing the position of the top block of the tower
 - height is the tower height

There are no checks on the callbacks functions (e.g. the callbacks are NOT run inside pcall)! Be responsible and verify your integration.

## Uninstall

This mod does create any files, temporary or persistent. This mod does not insert
any records into server's database. To uninstall, simply remove the mod directory.

## License

BSD-3. See LICENSE for details.


